<?php

namespace Drupal\feeds_fetcher_post\Feeds\Fetcher\Form;

use Drupal\Core\Form\FormStateInterface;
use Drupal\feeds\FeedInterface;
use Drupal\feeds\Feeds\Fetcher\Form\HttpFetcherFeedForm;

/**
 * Provides a form on the feed edit page for the HttpFetcher.
 */
class HttpFetcherPostFeedForm extends HttpFetcherFeedForm {

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state, FeedInterface $feed = NULL) {
    parent::buildConfigurationForm($form, $form_state, $feed);

    $form = parent::buildConfigurationForm($form, $form_state, $feed);

    $form['post_parameter'] = [
      '#title' => $this->t('Post parameters:'),
      '#description' => $this->t("List of Post values pairs, one pair per line: KEY: VALUE"),
      '#type' => 'textarea',
      '#default_value' => $feed->getConfigurationFor($this->plugin)['post_parameter'],
    ];
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state, FeedInterface $feed = NULL) {
    parent::submitConfigurationForm($form, $form_state, $feed);
    $feed_config = $feed->getConfigurationFor($this->plugin);
    $feed_config['post_parameter'] = $form_state->getValue('post_parameter');
    $feed->setConfigurationFor($this->plugin, $feed_config);
  }

}
